(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('fast-deep-equal')) :
  typeof define === 'function' && define.amd ? define(['exports', 'fast-deep-equal'], factory) :
  (global = global || self, factory(global.resq = {}, global.deepEqual));
}(this, function (exports, deepEqual) { 'use strict';

  deepEqual = deepEqual && deepEqual.hasOwnProperty('default') ? deepEqual['default'] : deepEqual;

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};
      var ownKeys = Object.keys(source);

      if (typeof Object.getOwnPropertySymbols === 'function') {
        ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
          return Object.getOwnPropertyDescriptor(source, sym).enumerable;
        }));
      }

      ownKeys.forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    }

    return target;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  function _construct(Parent, args, Class) {
    if (isNativeReflectConstruct()) {
      _construct = Reflect.construct;
    } else {
      _construct = function _construct(Parent, args, Class) {
        var a = [null];
        a.push.apply(a, args);
        var Constructor = Function.bind.apply(Parent, a);
        var instance = new Constructor();
        if (Class) _setPrototypeOf(instance, Class.prototype);
        return instance;
      };
    }

    return _construct.apply(null, arguments);
  }

  function _isNativeFunction(fn) {
    return Function.toString.call(fn).indexOf("[native code]") !== -1;
  }

  function _wrapNativeSuper(Class) {
    var _cache = typeof Map === "function" ? new Map() : undefined;

    _wrapNativeSuper = function _wrapNativeSuper(Class) {
      if (Class === null || !_isNativeFunction(Class)) return Class;

      if (typeof Class !== "function") {
        throw new TypeError("Super expression must either be null or a function");
      }

      if (typeof _cache !== "undefined") {
        if (_cache.has(Class)) return _cache.get(Class);

        _cache.set(Class, Wrapper);
      }

      function Wrapper() {
        return _construct(Class, arguments, _getPrototypeOf(this).constructor);
      }

      Wrapper.prototype = Object.create(Class.prototype, {
        constructor: {
          value: Wrapper,
          enumerable: false,
          writable: true,
          configurable: true
        }
      });
      return _setPrototypeOf(Wrapper, Class);
    };

    return _wrapNativeSuper(Class);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    }

    return _assertThisInitialized(self);
  }

  function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
  }

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) {
      for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

      return arr2;
    }
  }

  function _iterableToArray(iter) {
    if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
  }

  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance");
  }

  function getElementType(type) {
    if (typeof type === 'string') {
      return type;
    }

    if (typeof type === 'function') {
      return type.name;
    }
  }

  function findStateNode(element) {
    if (element.stateNode instanceof HTMLElement) {
      return element.stateNode;
    }

    if (typeof element.type === 'function' && element.child && element.child.stateNode instanceof HTMLElement) {
      return element.child.stateNode;
    }
  }

  function buildNodeTree(element) {
    var tree = {
      children: []
    };

    if (!element) {
      return tree;
    }

    tree.name = getElementType(element.type);
    tree.node = findStateNode(element);
    tree.props = _objectSpread({}, element.memoizedProps);
    tree.state = _objectSpread({}, element.memoizedState);

    if (element.child) {
      tree.children.push(element.child);
      var child = element.child;

      while (child.sibling) {
        tree.children.push(child.sibling);
        child = child.sibling;
      }
    }

    tree.children = tree.children.map(function (child) {
      return buildNodeTree(child);
    });
    return tree;
  }
  function findInTree(tree, searchFn) {
    var selectFirst = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    var returnArray = [];
    var stack = tree;

    while (stack.length || selectFirst && !returnArray.length) {
      var node = stack.shift();

      if (node.children && node.children.length) {
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = node.children[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var child = _step.value;

            if (searchFn(child)) {
              returnArray.push(child);
            }

            stack.push(child);
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      }
    }

    return returnArray;
  }
  function findSelectorInTree(selectors, tree) {
    var selectFirst = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    var searchFn = arguments.length > 3 ? arguments[3] : undefined;
    var treeArray = [tree];
    selectors.forEach(function (selector) {
      treeArray = findInTree(treeArray, function (child) {
        if (searchFn && typeof searchFn === 'function') {
          return searchFn(child);
        }

        return child.name === selector;
      }, selectFirst);
    });
    return treeArray;
  }
  function filterNodesBy(nodes, key, obj) {
    var filtered = [];

    var interator = function interator(el) {
      if (deepEqual(obj, el[key])) {
        filtered.push(el);
      }
    };

    nodes.forEach(interator);
    return filtered;
  }

  var RESQNodes =
  /*#__PURE__*/
  function (_Array) {
    _inherits(RESQNodes, _Array);

    function RESQNodes(nodes) {
      var _getPrototypeOf2;

      _classCallCheck(this, RESQNodes);

      return _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(RESQNodes)).call.apply(_getPrototypeOf2, [this].concat(_toConsumableArray(nodes))));
    }

    _createClass(RESQNodes, [{
      key: "byProps",
      value: function byProps(props) {
        var filtered = filterNodesBy(this, 'props', props);
        return new RESQNodes(filtered);
      }
    }, {
      key: "byState",
      value: function byState(state) {
        var filtered = filterNodesBy(this, 'state', state);
        return new RESQNodes(filtered);
      }
    }]);

    return RESQNodes;
  }(_wrapNativeSuper(Array));

  var RESQNode =
  /*#__PURE__*/
  function (_Object) {
    _inherits(RESQNode, _Object);

    function RESQNode(item, nodes) {
      var _this;

      _classCallCheck(this, RESQNode);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(RESQNode).call(this, item));
      _this.nodes = nodes;

      for (var key in item) {
        _this[key] = item[key];
      }

      return _this;
    }

    _createClass(RESQNode, [{
      key: "byProps",
      value: function byProps(props) {
        var filtered = filterNodesBy(this.nodes, 'props', props)[0];
        return new RESQNode(filtered, this.nodes);
      }
    }, {
      key: "byState",
      value: function byState(state) {
        var filtered = filterNodesBy(this.nodes, 'state', state)[0];
        return new RESQNode(filtered, this.nodes);
      }
    }]);

    return RESQNode;
  }(_wrapNativeSuper(Object));

  var RESQ =
  /*#__PURE__*/
  function () {
    _createClass(RESQ, null, [{
      key: "getRootComponent",
      value: function getRootComponent() {
        var element = document.querySelector('#root');
        return element._reactRootContainer._internalRoot.current;
      }
    }]);

    function RESQ(selector) {
      _classCallCheck(this, RESQ);

      this.selectors = selector.split(' ').filter(function (el) {
        return !!el;
      }).map(function (el) {
        return el.trim();
      });
      this.rootComponent = RESQ.getRootComponent();
      this.tree = buildNodeTree(this.rootComponent);
    }

    _createClass(RESQ, [{
      key: "find",
      value: function find() {
        this.nodes = new RESQNodes(findSelectorInTree(this.selectors, this.tree, true));
        return new RESQNode(this.nodes[0], this.nodes);
      }
    }, {
      key: "findAll",
      value: function findAll() {
        return new RESQNodes(findSelectorInTree(this.selectors, this.tree));
      }
    }]);

    return RESQ;
  }();

  var REACT_VERSION_MATCHERS = {
    V16: '_reactRootContainer',
    SSR: '_reactListenersID'
  };
  function waitToLoadReact(timeout) {
    var isReact16 = function isReact16() {
      var walker = document.createTreeWalker(document);

      while (walker.nextNode()) {
        if (walker.currentNode.hasOwnProperty(REACT_VERSION_MATCHERS.V16)) {
          return REACT_VERSION_MATCHERS.V16;
        }
      }
    };

    var hasReactHandler = function hasReactHandler() {
      var handlerExists = !!Object.keys(document).filter(function (prop) {
        return prop.startsWith(REACT_VERSION_MATCHERS.SSR);
      }).length;

      if (handlerExists) {
        return REACT_VERSION_MATCHERS.SSR;
      }
    };

    var hasReactVersion = function hasReactVersion() {
      return isReact16() || hasReactHandler();
    };

    return function () {
      return new Promise(function (resolve, reject) {
        var timedout = false;

        var tryToFindApp = function tryToFindApp() {
          var reactVersion = hasReactVersion();

          if (reactVersion) {
            global.reactVersion = reactVersion;
            return resolve(true);
          }

          if (timedout) {
            return;
          }

          setTimeout(tryToFindApp, 200);
        };

        tryToFindApp();
        setTimeout(function () {
          timedout = true;
          reject('Timed out');
        }, timeout);
      });
    }();
  }

  var resq$ =
  /*#__PURE__*/
  function () {
    var _ref = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee(selector) {
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (global.reactVersion) {
                _context.next = 9;
                break;
              }

              _context.prev = 1;
              _context.next = 4;
              return waitToLoadReact(5000);

            case 4:
              _context.next = 9;
              break;

            case 6:
              _context.prev = 6;
              _context.t0 = _context["catch"](1);
              throw new Error('Error while looking for React Component %s', selector, _context.t0);

            case 9:
              return _context.abrupt("return", new RESQ(selector).find());

            case 10:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[1, 6]]);
    }));

    return function resq$(_x) {
      return _ref.apply(this, arguments);
    };
  }();
  var resq$$ =
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2(selector) {
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              if (global.reactVersion) {
                _context2.next = 9;
                break;
              }

              _context2.prev = 1;
              _context2.next = 4;
              return waitToLoadReact(5000);

            case 4:
              _context2.next = 9;
              break;

            case 6:
              _context2.prev = 6;
              _context2.t0 = _context2["catch"](1);
              throw new Error('Error while looking for React Component %s', selector, _context2.t0);

            case 9:
              return _context2.abrupt("return", new RESQ(selector).findAll());

            case 10:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[1, 6]]);
    }));

    return function resq$$(_x2) {
      return _ref2.apply(this, arguments);
    };
  }();

  exports.resq$ = resq$;
  exports.resq$$ = resq$$;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
